import tkinter as tk
from tkinter.scrolledtext import ScrolledText

class Window(tk.Frame):
	def __init__(self,root):
		style={
			"bg":"#3399FF",
			"txtWidth":55,
			"btnFont":("Meiryo UI",11)
		}

		root.title("テキストルーレット")
		root.geometry("600x400")
		root.resizable(0,0)
		root.option_add("*font",("Meiryo UI",12))
		root.config(bg=style["bg"])

		import txtLret
		self.event=txtLret.winEvent(self)

		super().__init__(root,cnf={"background":style["bg"]})
		self.pack(pady=5)

		tk.Label(
			self,
			fg="#000099",
			bg=style["bg"],
			text="ルーレットしたい値を入れてね。"
		).pack(pady=5)

		self.txtList=ScrolledText(
			self,
			width=style["txtWidth"],
			height=13
		)
		self.txtList.pack()

		self.btns=tk.Frame(self,cnf={"background":style["bg"]})

		self.lretMainBtn=tk.Button(
			self.btns,
			width=20,
			font=style["btnFont"],
			text="Let's ルーレット!"
		)
		self.lretMainBtn.pack(padx=10,side="left")
		self.lretMainBtn.bind("<ButtonRelease>",self.event.lretMain)

		self.lretDefaultBtn=tk.Button(
			self.btns,
			width=10,
			font=style["btnFont"],
			text="MH武器"
		)
		self.lretDefaultBtn.pack(padx=10,side="left")
		self.lretDefaultBtn.bind("<ButtonRelease>",self.event.lretDefault)

		self.btns.pack(pady=10)

		self.resultListValue=tk.StringVar()
		self.resultList=tk.Entry(
			self,
			width=style["txtWidth"]+2,
			textvariable=self.resultListValue
		)
		self.resultList.pack()

win=Window(root=tk.Tk())
win.mainloop()